-- Pairidaeza/charbagh
-- Author: adan_eslavo
-- DateCreated: 19/12/2017
-- 2018-01-25 updated by Infixo
-- 2024-05-29 updated by pineappledan
--------------------------------------------------------------
local eBuildingCharbaghGlobalDummy = GameInfoTypes.BUILDING_D_FOR_CHARBAGH_1
local eBuildingCharbaghLocalDummy = GameInfoTypes.BUILDING_D_FOR_CHARBAGH_2
local eImprovementCharbagh = GameInfoTypes.IMPROVEMENT_PERSIA_CHARBAGH
local eCivilizationPersia = GameInfoTypes.CIVILIZATION_PERSIA

function CharbaghGoldenAgeStartBonus(iPlayer, bStart, iTurns)
	local pPlayer = Players[iPlayer]
	
	if bStart == true then
		local pCapital = pPlayer:GetCapitalCity()
		pCapital:SetNumRealBuilding(eBuildingCharbaghGlobalDummy, 1)
	else
		local pCapital = pPlayer:GetCapitalCity()
		pCapital:SetNumRealBuilding(eBuildingCharbaghGlobalDummy, 0)
	end
end

--give charbagh GPrate bonus to all players if they are working charbaghs
function CharbaghGPRateBonus(iPlayer)
	local pPlayer = Players[iPlayer]
	local pCapital = pPlayer:GetCapitalCity()
	
	for city in pPlayer:Cities() do
		local iNumCharbaghDummies = city:CountNumWorkedImprovement(eImprovementCharbagh, false)
		if iNumCharbaghDummies > 0 then
			city:SetNumRealBuilding(eBuildingCharbaghLocalDummy, iNumCharbaghDummies)
		end
	end
end

if Game.IsCivEverActive(eCivilizationPersia) then
	GameEvents.PlayerGoldenAge.Add(CharbaghGoldenAgeStartBonus)
	GameEvents.PlayerDoTurn.Add(CharbaghGPRateBonus)
end